#! /usr/bin/python

def tent(x, a):
    if x <= 0.5:
        return a * x
    else:
        return a * (1 - x)
        
def it(x, a, n):
    for i in range(n):
        x = tent(x, a)
    return x
    


from pylab import *

rc('text', usetex=True)
rc('font', family='serif')

nmap = 10
npoint = 1000
x = linspace(0, 1, npoint + 1)
y = empty(npoint + 1, dtype = float)

counter = 0
for a in linspace(0.5, 2, 4):
    for n in range(nmap):
        for i in range(npoint + 1):
            y[i] = it(x[i], a, n + 1)
        close('all')
        figure(0, figsize = (6, 6))
        axis([-0.1, 1.1, -0.1, 1.1])
        plot(x, y, 'b')
        title(r'iterated tent map, $a = {:6.4f}$, $n = {:d}$'.format(a, n + 1))
        xlabel(r'$x$')
        ylabel(r'$\mbox{tent}(x)$')
        counter += 1
        savefig('it{:03d}.png'.format(counter))
close('all')
