#! /usr/bin/python

def tent(x, a):
    if x <= 0.5:
        return a * x
    else:
        return a * (1 - x)



from pylab import *

rc('text', usetex=True)
rc('font', family='serif')

n = 500 # number of points over a
m = 250 # number of stored y points for a given a
k = 2000 # number of not-stored y points to start up

a = (arange(n, dtype = float) + 1.0) / n * 2

y = empty((n, m), dtype = float)
xp = array(linspace(0, 1, 101))
yp1 = empty(len(xp), dtype = float)
for i in range(len(xp)):
    yp1[i] = tent(xp[i], 1)

for ia in range(n):
    aa = a[ia]
    x0 = 0.5
    for i in range(k):
        x0 = tent(x0, aa)
    for i in range(m):
        y[ia][i] = x0 = tent(x0, aa)
    close('all')
    figure(0, figsize = (6, 6))
    yp = aa * yp1
    plot(xp, yp, 'b-')
    plot(xp, xp, 'k-', linewidth = 0.25)
    plot(y[ia][:(m - 1)], y[ia][1:], 'r.')
    axis([-0.1, 1.1, -0.1, 1.1])
    xlabel(r'$x_k$')
    ylabel(r'$x_{k+1}$')
    title(r'tent mapping, $a = {:6.4f}$'.format(aa))
    xticks(linspace(0, 1, 11))
    yticks(linspace(0, 1, 11))
    savefig('tent-par-' + str(ia) + '.png')

close('all')
figure(1, figsize = (12, 6))
axis([-0.1, 2.1, -0.1, 1.1]) 
for i in range(n):
    plot(ones(m) * a[i], y[i], 'b.', markersize = 1)
xlabel(r'$a$')
ylabel(r'$y_k$')
title(r'tent mapping, bifurcation diagram')
xticks(linspace(0, 2, 9))
yticks(linspace(0, 1, 6))
savefig('tent.png')
close('all')

